﻿Type=StaticCode
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public Const TipoNroMovil="NroMovil" As String
	Public Const TipoNombre="Nombre" As String
	Public Const TipoNotificacion="Notificacion" As String
	Public Const TipoLuz="Luz" As String
	Public Const TipoSonido = "Sonido" As String
	Public Const TipoVibrar="Vibrar" As String
	Public Const TipoVersion="Version" As String
	Public Const TipoVersionDB="VersionDB" As String
	Public Const TipoKey="ContactoKey" As String
	Public const TipoPais="TipoPais" As String
	
	Public Conf As KeyValueStore	
	Public Yo As clsContacto
	Private oSQL As SQL
	Dim oSQLTmp As SQL
		
	Public ListaConversaciones As Map
	Public ListaContactos As Map
	'Public ListaContactosFacebook As Map
	
	Type ItemImagenCache (ID As String, Link As String)
		
End Sub

Public Sub Get(sKey As String, Defecto As Object) As Object
	
	Dim r As Object
	
	r=Defecto
	
	Try
		If Conf=Null Or Conf.IsInitialized=False Then
			Init
		End If
		If Conf.ContainsKey(sKey)=True Then
			r=Conf.GetSimple(sKey)
		Else
			Conf.PutSimple(sKey,Defecto)
		End If
		
	Catch 
		Log("Config - Get - " & LastException.Message)
	End Try
	
	Return r
	
End Sub

Public Sub Set(sKey As String, Valor As String) 
	
	Try
		If Conf=Null Or Conf.IsInitialized=False Then
			Init
		End If
		Conf.putSimple(sKey,Valor)
	Catch 
		Log("Config - Set - " & LastException.Message)
	End Try		
	
End Sub

Sub GetYo() As clsContacto

	Dim r As clsContacto
	
	Try
		If Yo=Null Or Yo.IsInitialized=False Then
			If Conf=Null Or Conf.IsInitialized=False Then
				Init
			End If
			
			r.Initialize
			
			If Conf.ContainsKey(TipoKey)=True Then
				r.Key=Conf.GetSimple(TipoKey)
			Else
				r.Key=""
			End If
			If Conf.ContainsKey(TipoNroMovil) = True Then
				r.NroMovil=Conf.GetSimple(TipoNroMovil)
			Else
				r.NroMovil=0
			End If
			If Conf.ContainsKey(TipoNombre) = True Then
				r.Nombre=Conf.GetSimple(TipoNombre)
			Else
				r.Nombre=""
			End If
			
			If Conf.ContainsKey(TipoPais) = True Then
				r.pais=Conf.GetSimple(TipoPais)
			Else
				r.pais=""
			End If
			
			Yo=r
		Else
			r=Yo
		End If
	Catch 
		Log("Config - GetYo - " & LastException.Message)
	End Try
	
	Return r

End Sub




'Public Sub SetYoTmpGK(sGK As String)
'
'	Try
'		
'		If Conf=Null Or Conf.IsInitialized=False Then
'			Init
'		End If
'			
'		Conf.putsimple(TipoTmpGoogleKey,sGK)
'		
'		If Yo=Null Or Yo.IsInitialized=False Then
'			GetYo
'		Else
'			Yo.sTmpGoogleKey=sGK
'		End If
'	Catch 
'		Log("Config - SetYoTmpGK - " & LastException.Message)
'	End Try
'	
'
'End Sub


Public Sub SetYo(Valores As Map)

	Try
		
		Dim i As Int
		Dim j As Int
		Dim sValor As String
		Dim sClave As String
		
		If Valores<>Null And Valores.IsInitialized=True And Valores.Size>0 Then
			If Conf=Null Or Conf.IsInitialized=False Then
				Init
			End If
		
			j=Valores.Size-1
			For i=0 To j
				sClave=Valores.GetKeyAt(i)
				sValor=Valores.GetValueAt(i)
				Conf.putsimple(sClave,sValor)
				
			Next
			Yo=Null
			GetYo
		End If
		
	Catch 
		Log("Config - SetYo - " & LastException.Message)
	End Try
	

End Sub

Private Sub Init

	Try
		Conf.Initialize(File.DirInternal, "datastore")
	Catch 
		Log("Config - Init - " & LastException.Message)
	End Try


End Sub

Public Sub HasKey As Boolean
	
	Dim r As Boolean
	
	r=False
	
	Try
		If Yo=Null Or Yo.IsInitialized=False Then
			GetYo
		End If
		
		If Yo.key<>Null And Yo.key.Trim.Length>0 Then
			r=True
		End If
		
	Catch 
		Log("Config - HasGK - " & LastException.Message)
	End Try
	
	Return r
	
End Sub


Public Sub HasNum As Boolean
	
	Dim r As Boolean
	
	r=False
	
	Try
		If Yo=Null Or Yo.IsInitialized=False Then
			GetYo
		End If
		'If Yo.IDFace<>Null AND Yo.idface.Trim.Length>0 Then
		If Yo.NroMovil>0 Then
			r=True
		End If
		
	Catch 
		Log("Config - HasFaceID - " & LastException.Message)
	End Try
	
	Return r
	
End Sub

Public Sub HasNombre As Boolean
	
	Dim r As Boolean
	
	r=False
	
	Try
		If Yo=Null Or Yo.IsInitialized=False Then
			GetYo
		End If
		
		If Yo.nombre<>Null And Yo.nombre.Trim.Length>0 Then
			r=True
		End If
		
	Catch 
		Log("Config - HasNombre - " & LastException.Message)
	End Try
	
	Return r
	
End Sub

Public Sub GetSQL() As SQL
	
	Dim rSQL As SQL
	
	Try
		
		If oSQL=Null Or oSQL.IsInitialized=False Then
			oSQL.Initialize(File.DirInternal, "secret", False)
		End If
				
		rSQL=oSQL

	Catch 
		Log("Config - GetSQL - " & LastException.Message)
	End Try

	Return rSQL
	
End Sub


Sub VersionNueva() As Boolean
	
	Dim pm As PackageManager
	Dim VersionCode As Int
	Dim VersionDB As Int
	Dim RegisteredVersion As Int
	Dim RegisteredDB As Int	
	Dim bCopiar As Boolean
	
	

	Try
		VersionCode=pm.GetVersionCode ("eitorteam.privapp")
		Log("App Version: " & VersionCode)
		
		RegisteredVersion=Get(TipoVersion,0)
		RegisteredDB=Get(TipoVersionDB,0)

		bCopiar=False
		
		If File.Exists(File.DirInternal,"secret")=False Then
			'si no existe, copio el original al cache
			File.Copy(File.DirAssets, "secret",File.DirInternalCache,"secret")
			bCopiar=True
		Else
			'si existe, copio el original al cache para leer la version de la DB
			File.Copy(File.DirAssets, "secret",File.DirInternalCache,"secret")
			oSQLTmp.Initialize(File.DirInternalCache,  "secret",  False)
			
			VersionDB=DBUtils.GetDBVersion(oSQLTmp) 'se supone que lo inicialicé antes
			Log("DB Version: " & VersionDB)
			oSQLTmp.Close
			If VersionDB<>RegisteredDB Then
				bCopiar=True
			End If
		End If
		
		If bCopiar=True Then
			'si el archivo no existía o la versión es distinta, copio del cache a la carpeta de la app
        	File.Copy(File.DirInternalCache,"secret",File.DirInternal,"secret")
			oSQL.Close
			oSQL.Initialize(File.DirInternal, "secret",  False)
			VersionDB=DBUtils.GetDBVersion(oSQL)
			Set(TipoVersionDB,VersionDB)
    	End If
			
		If RegisteredVersion<>VersionCode Then
			'Set(TipoGoogleKey,"")
			Set(TipoVersion,VersionCode)
			bCopiar=True
		End If

'		tmpGK=Get(TipoGoogleKey,"")
'		
'		If tmpGK.Trim.Length=0 Then
'		
'			GetYo
'			
'			If HasFaceID  Then
'				IniciarProcesoGK
'			Else
'				StartActivity(Contactos)
'			End If
'		End If
		
		
	Catch
		Log("Config - VersionNueva - " & LastException.Message)
	End Try

	Return bCopiar
	

End Sub

Public Sub GetContactosDB As Map

	Dim oSQL As SQL
	Dim r As Map
	Dim i, j As Int
	
	
	Try
		If ListaContactos=Null Or ListaContactos.IsInitialized=False Then
			ListaContactos.Initialize

			j = 2
				For i = 0 To j
					Dim c As clsContacto
					c.Initialize

					c.NroMovil = i
					c.Nombre = "User " & i
					c.Oculto = 0
					c.Bloqueado = 0
					c.CantidadContactos = 1
					c.Key = "C" & i
						
					ListaContactos.put(c.NroMovil, c)
					
				Next
				
			End If
		
		r = ListaContactos
		
	Catch
		Log ("Config - GetContactosDB - " & LastException.Message)
	End Try
	
	Return r
	
	
End Sub

Public Sub HasContactos As Boolean
	
	Dim r As Boolean
	
	r=False
	
	Try
		
		If ListaContactos=Null Or ListaContactos.IsInitialized=False Or ListaContactos.Size=0 Then
			ListaContactos = GetContactosDB
		End If
		
		If ListaContactos<>Null And ListaContactos.IsInitialized=True Then
			If ListaContactos.Size>0 Then
				r=True
			End If
		End If
		
	Catch
		Log("Config - HasContactos - " & LastException.Message)
	End Try
	
	Return r
	
End Sub

'Public Sub HasContactosFB As Boolean
'
'	Dim r As Boolean
'	
'	r=False
'	
'	Try
'		
'		If ListaContactosFacebook<>Null And ListaContactosFacebook.IsInitialized=True Then
'			If ListaContactosFacebook.Size>0 Then
'				r=True
'			End If
'		End If
'	Catch
'		Log("Config - HasContactosFB - " & LastException.Message)
'	End Try
'	
'	Return r
'	
'End Sub


Sub ContactoBloqueadoDesbloqueado(IdContacto As Int)

	'If IsPaused(Contactos)=False Then
	Dim c As clsContacto
	Dim m As Map
	Dim oSQL As SQL
	
	Try
		m.Initialize
		m.Put("ContactoID",IdContacto)
		If ListaContactos.ContainsKey(IdContacto)=True Then
			oSQL=GetSQL
			c=ListaContactos.Get(IdContacto)
			DBUtils.UpdateRecord(oSQL,"Contactos","ContactoBloqueado",c.Bloqueado,m)
		End If
		
		CallSubDelayed(Main, "ListaContactosCargar")
		'End If
	Catch
		Log("Config - ContactoBloqueadoDesbloqueado - " & LastException.Message)
	End Try
End Sub

Sub ContactoOcultadoDesocultado(IdContacto As Int)
	
	Dim c As clsContacto
	Dim m As Map
	Dim oSQL As SQL
	
	Try
		m.Initialize
		m.Put("ContactoID",IdContacto)
		If ListaContactos.ContainsKey(IdContacto)=True Then
			oSQL=GetSQL
			c=ListaContactos.Get(IdContacto)	
			DBUtils.UpdateRecord(oSQL,"Contactos","ContactoOculto",c.Oculto,m)
		End If
		
		'If IsPaused(Contactos)=False Then
		CallSubDelayed(Main, "ListaContactosCargar")
		'End If
	Catch
		Log("Config - ContactoOcultadoDesocultado - " & LastException.Message)
	End Try
	
End Sub


